/*!
 * org.tts.js.core v1.0
 *   Core/Object.js v1.0
 *
 * (c) 2015 TTS Design
 * code.ttsdesign.net/license
 */

Object.prototype.contains = function (string)
{
	return Object.keys(this).Contains(string);
};

Object.prototype.item = function (path, value)
{
	elements = path.split('.');
	element = elements.shift();
	if ((typeof(this[element]) !== 'undefined') || (typeof(value) !== 'undefined')) {
		if (elements.length == 0) {
			if (typeof(this[element]) === 'undefined') {
				this[element] = value;
				return true;
			}
			return this[element];
		}
		if (typeof(this[element]) === 'undefined') {
			this[element] = new Object();
			return this[element].Item(elements.join('.'), value);
		}
		if (typeof(this[element]) == 'object') {
			return this[element].Item(elements.join('.'), value);
		}
	}
	return null;
}

Object.prototype.join = function (separator)
{
	var s = "";
	var keys = Object.keys(this);
	for (var i=0; i<keys.length; i++) {
		if (i != 0) {
			s += separator;
		}
		s += keys[i] + "=" + this[keys[i]].toString();
	}
	return s;
};

Object.prototype.keys = function ()
{
	console.log(this.prototype.__proto__);


}

Object.prototype.limitElements = function (elements)
{
	_elements = this;
	Object.keys(this).forEach(function (e, i, a) {
		var ok = false;		
		elements.forEach(function (ee, ii, aa) {
			if (e == ee) {
				ok = true;
			}
		});
		if (!ok) {
			_elements.removeElement(e);
		}
	});
	return this;
}

Object.prototype.match = function (obj)
{
	t = this;
	var r = true;
	Object.keys(obj).forEach (function(element, index, array) {
		if (obj[element].toString() != t[element].toString()) {
			r = false;
		}
	});
	return r;
}

Object.prototype.remove = function (path)
{
	elements = path.split('.');
	element = elements.shift();
	if (typeof(this[element]) === 'undefined') {
		return false;
	}
	if (elements.length == 0) {
		delete this[element];
		return true;
	}
	return this[element].Remove(elements.join('.'));
}

Object.prototype.Contains = Object.prototype.contains;
Object.prototype.Item = Object.prototype.item;
Object.prototype.Join = Object.prototype.join;
Object.prototype.LimitElements = Object.prototype.limitElements;
Object.prototype.Match = Object.prototype.match;
Object.prototype.Remove = Object.prototype.remove;
Object.prototype.RemoveElement = Object.prototype.Remove;
