
ExecSync = require('TTS/js/System').ExecSync;

Uuid = {
	TTS: {
		UserId: function (user) {
			return Uuid.v5('ns:URL', 'users.ttscloud.net/'+user);
		},
		Id: function (s) {
			if (!s) {	s = Uuid.v1();	}
			return Uuid.v5('ns:URL', 'ttscloud.net/'+s);
		},
		Key: function (u, s) {
			if (!s) {	s = Uuid.v1();	}
			return Uuid.v5('ns:URL', 'keys.ttscloud.net/'+u+'/'+s);
		}
	},
	v1: function () {
		return ExecSync('uuid -v 1').trim();
	},
	v3: function (ns, s) {
		if (!ns) {	ns = 'ns:URL';	}
		if (!s)  {	s = Uuid.v1();	}
		return ExecSync('uuid -v 3 '+ns+' '+s).trim();
	},
	v4: function () {
		return ExecSync('uuid -v 4').trim();
	},
	v5: function (ns, s) {
		if (!ns) {	ns = 'ns:URL';	}
		if (!s)  {	s = Uuid.v1();	}
		return ExecSync('uuid -v 3 '+ns+' '+s).trim();
	}
}

if (typeof(module) != 'undefined') {
	module.exports = Uuid;
} else {
	this.Uuid = Uuid;
}
