/*
(function() {
	WeekDays = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
	_Date = {
		DayOfWeek: function (d) {
			data = d.split('-');
			_d = new Date(data[0], data[1], data[2]);
			//_d = new Date();
			return WeekDays[_d.getDay()];
		},
		DateRange: function (start, end) {
			range = [];

			d = new Date(start);
			end = new Date(end);
			while(d < end) {
				range.push(d.toISOString());
				d.setDate(d.getDate()+1);
			}
			range.push(end.toISOString());
			return range;

		},
		ExpandRange: function (duration, start, end) {
			data = duration.split(':');
			time = Number(data[0] * 60) + Number(data[1]) + Number(data[2] / 60);

			range = [];
			end = new Date(end);
			d = new Date(start);
			while(d < end) {
				range.push(d.toISOString());
				d.setMinutes(d.getMinutes()+time);
			}
			range.push(end.toISOString());
			return range;
		}
	};


	if (typeof(module) != 'undefined') {
		module.exports = _Date;
	} else {
		this._Date = _Date;
	}

})();
*/
var util = require('util');

Date.prototype.DayOfWeek = function ()
{
	WeekDays = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
	return WeekDays[this.getDay()];

}

Date.prototype.Range = function (duration, end)
{
	data = duration.split(':');
	time = Number(data[0] * 60) + Number(data[1]) + Number(data[2] / 60);
	
	range = new Array();
	e = (util.isDate(end)) ? end : new Date(end);
	d = new Date(this.toString());
	if (e < d) {
		return range;
	}
	while(d < e) {
		range.push(d.toISOString());
		d.setMinutes(d.getMinutes()+time);
	}
	range.push(e.toISOString());
	return range;
}

Date.prototype.WithinRange = function (start, end)
{
	s = (util.isDate(start)) ? start : new Date(start);
	e = (util.isDate(end)) ? end : new Date(end);

	if (s < e) {
		if ((this > s) && (this < e)) {
			return true;
		}
	} else {
		if ((this > e) && (this < s)) {
			return true;
		}
	}
	return false;
}
