/*!
 * org.tts.js.core v1.0
 *   Core/Array.js v1.0
 *
 * (c) 2015 TTS Design
 * code.ttsdesign.net/license
 */

Array.prototype.contains = function (value)
{
	for (var i=0; i<this.length; i++) {
		if (this[i] == value) {
			return true;
		}
	}
	return false;
};

Array.prototype.removeDuplicates = function ()
{
	this.forEach(function (e, i, a) {
		a.forEach(function (ee, ii, aa) {
			if (ii > i) {
				if (e === ee) {
					aa.removeIndex(ii);
				}
			}
		});
	});
	return this;
}

Array.prototype.removeElement = function (element)
{
	this.forEach(function (e, i, a) {
		if (e === element) {
			a.removeIndex(i);
			return this;
		}
	});
	return this;
}

Array.prototype.removeIndex = function (index)
{
	for (i=index; i<this.length; i++) {
		this[i] = this[i+1];
	}
	this.pop();
	return this;
}

Array.prototype.Contains = Array.prototype.contains;
Array.prototype.RemoveDuplicates = Array.prototype.removeDuplicates;
Array.prototype.RemoveElement = Array.prototype.removeElement;
Array.prototype.RemoveIndex = Array.prototype.removeIndex;
