////////////////////////////////////////////////////////////////////////////////
//          File Header
//  File: index.js (Js:Data/index.js)
//  Description: JS Data Modules
//  Version: 1.0.0 (09/15/2014)
//  Url: http://code.ttsdesign.net/tiki-index.php?page=Js_Data
//  Bugs: http://bugzilla.ttsdesign.net/describecomponents.cgi?product=Js%3AData
//  License: GPL-1.0+
////////////////////////////////////////////////////////////////////////////////

(function() {
	var Data = {
		Base64: {
			Decode: require('./Base64').Decode,
			Encode: require('./Base64').Encode
		},
		Uuid: require('./Uuid')
	};

	if (typeof(module) != 'undefined') {
		module.exports = Data;
	} else {
		this.Data = Data;
	}

})();
